program morseuebungsprogramm;
{$R+}


{1991, Bernd DG2NEQ @ DB0BOX}

{Hinweis zu Morseschreiber: <ESC> bricht ab, <SPACE> lscht den Bildschirm}
{           Morselektion:   <ESC> bricht ab
                            Lektion: 1 ... 19; Buchstaben wie im Kurs von
                                               DL0JK
                            15 Fnfergruppen}
{           Morsefile:      Fragt nach filename im aktuellen Verzeichnis}


{Tongenerator und CW-Taste werden an eine Serielle Schnittstelle angeschlossen
 (Siehe Schaltplan).
 Das Interface ist so ausgelegt, so da es auch mit SUPER-MORSE 3.16 zusammen-
 arbeitet (RS-232: Input CTS, Sense +; Output DTR, Sense +}

{GRAPHDRIVER und GRAPHMODE mssen entsprechend der verwendeten Graphikkarte
 gesetzt werden. Bei INITGRAPH ist der Pfad des BGI-Treibers anzugeben.
 Getestet nur mit Olivetti-Graphik und CGA640*200}



{Hinweis zu EXTRAPAUSE: Hinter jedem Zeichen werden zustzlich zu den
                        Standard-Pausen noch zustzlich Pausen der Lnge
                        EXTRAPAUSE*Punktlnge eingefgt.}






uses crt,graph;

const
    {comport=$3f8}            {Anschlu an COM1}
     comport=$2f8;            {Anschlu an COM2}



      olitaktcor= 0.971;   {Nur bei Olivetti M24 und M21.}
     {olitaktcor= 1.0;}    {Bei diesen Rechnern wird der Timer mit
                            3.6864MHz getaktet.
                            IBM: 14.31818MHz/4=3.579545MHz

                            Turbo-Pascal wei davon nichts - die Zeiten
                            fr DELAY sowie fr die Tonhhe mssen daher
                            um 3.579545/3.6864=0.971 korrigiert werden.}





      frequenz=800;    {800 oder 0}    {'0' stellt den eingebauten
                                        Lautsprecher ab}



      pointsperbaud=8;   {Anzahl der Graphik-Punkte die fr einen
                          Morse-Punkt bzw. Leerraum ausgegeben werden.
                          Fr bungsgeschwindigkeiten um 65BpM und einer
                          Graphikbreite von 640 Punkten ist 8 ganz angenehm.}




      morsecode:array[$20..$5f]of byte =
        ($00,$36,$4a,$ac,$00,$00,$00,$7a,
         $b4,$b6,$44,$54,$ce,$86,$56,$94,
         $fc,$7c,$3c,$1c,$0c,$04,$84,$c4,
         $e4,$f4,$e2,$aa,$ac,$8c,$54,$32,
         $00,$60,$88,$a8,$90,$40,$28,$d0,
         $08,$20,$78,$b0,$48,$e0,$a0,$f0,
         $68,$d8,$50,$10,$c0,$30,$18,$70,
         $98,$b8,$c8,$00,$00,$00,$00,$00);

type   lektionstype=1..19;

var    bpm:real;
       extrapause:integer;
       code:char;
       punktdauer:integer;
       frequenz_int:integer;
       textzeile:string;
       lektionsnr:lektionstype;
       nurneu:char;

procedure zeichenausgabe (zeichen:char);

var code:word;
    element:boolean;
    temp:word;
begin
  code:=word(morsecode[ord(upcase(zeichen))]) shl 8;
  if code=0 then delay (punktdauer*4)
  else
  begin
   while code <> $8000 do begin
      sound(trunc(frequenz*olitaktcor));
      port[comport+4]:=2;
      if (code and $8000) = $8000 then
         delay(punktdauer*3)
      else
         delay(punktdauer);

      nosound;
      port[comport+4]:=3;
      delay(punktdauer);
      code:=code shl 1;
   end;
   delay(punktdauer*(2+extrapause));
  end;
end;



procedure morseschreiber;

var graphmode,graphdriver:integer;
    x,y:integer;
    pause:integer;
    lastport:byte;
    dreipointsperbaud:integer;
    hoehe1,hoehe2:integer;

begin
graphdriver:=att400;
graphmode:=att400hi;
initgraph(graphdriver,graphmode,'c:\sprachen\tp');

pause:=trunc(100.0/bpm*60.0 / olitaktcor / pointsperbaud   );
dreipointsperbaud:=3*pointsperbaud;

hoehe1:=(getmaxy+1) div 25;
hoehe2:=(getmaxy+1) div 40;

repeat
  cleardevice;

  x:=1;
  repeat
    setlinestyle(userbitln,$8888,normwidth);
    line(x,1,x,getmaxy);
    x:=x+pointsperbaud;
    setlinestyle(userbitln,$8080,normwidth);
    line(x,1,x,getmaxy);
    x:=x+pointsperbaud;
    line(x,1,x,getmaxy);
    x:=x+pointsperbaud;
  until x>getmaxx;

  setlinestyle(solidln,0,normwidth);
  lastport:=1;

  for y:=1 to (getmaxy+1) div hoehe1  do
    for x:=0 to getmaxx  do
      begin
      if keypressed then
        begin x:=getmaxx;
              y:=(getmaxy+1) div hoehe1;
        end;
      delay(pause);
       if ( (port[comport+6] and 16) = 0 ) then
        begin
        if lastport=0 then  line(x,y*hoehe1-hoehe2,x,y*hoehe1-hoehe1);
        lastport:=1;
        putpixel(x,y*hoehe1-hoehe2,1);
        end
      else
        begin
        if lastport=1 then  line(x,y*hoehe1-hoehe2,x,y*hoehe1-hoehe1);
        lastport:=0;
        putpixel(x,y*hoehe1-hoehe1,1);
        end
      end;

repeat until keypressed;
code:=readkey;
until code=#27;

textmode(bw80);

end;




procedure morselektion;

const  lfdnr:array [0..40] of CHAR =
       ('e','l','v','0',
        'a','s','q',
        '2','t',
        'o','c',
        'd','5',
        'r','/',
        '9','i',
        'g','x',
        '4','f',
        'n','j',
        'u','7',
        'h',',',
        '=','.',
        'k','b',
        'p','3',
        'm','y',
        'z','w',
        '6','1',
        '?','8');

        lektionsende:array[0..20] of integer =
         (-1,3,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42);
var zeichen:char;
    lektionsanf:integer;
    gruppe,stelle:integer;
    ausgabe:text;

begin
  assign(ausgabe,'con');
  rewrite(ausgabe);

  randomize;
  writeln(ausgabe);
  writeln(ausgabe);


  if (upcase(nurneu)='J') or (upcase(nurneu)='Y') then
    lektionsanf:=lektionsende[lektionsnr-1]+1
      else
    lektionsanf:=0;

  zeichenausgabe('V');
  zeichenausgabe('V');
  zeichenausgabe('V');
  delay(1000);

  zeichenausgabe('#'); {commence traffic}
  delay(500);

  for gruppe:=0 to 14 do begin
  for stelle:=0 to 4 do begin

  zeichen:=lfdnr[random(lektionsende[lektionsnr]-lektionsanf+1)+lektionsanf];
  write(ausgabe,zeichen);
  zeichenausgabe(zeichen);

  if keypressed then
     begin
     code:=readkey;
     if code=#27 then begin
                        gruppe:=14;
                        stelle:=4;
                      end;
     end;

  end;
  write(ausgabe,' ');
  delay(punktdauer*(4+extrapause));
  if (gruppe mod 5) = 4 then writeln(ausgabe);
  end;


  zeichenausgabe('+'); {ar}

  writeln(ausgabe);
  writeln(ausgabe,'+');

  repeat until keypressed;
  code:=readkey;


end;




procedure morsefile;

var zeichen:char;
    stelle:integer;
    ausgabe:text;
    eingabe:text;
    filename:string[80];

begin
  assign(ausgabe,'con');
  rewrite(ausgabe);

  writeln;writeln;
  write('filename : ');
  readln(filename);
  assign(eingabe,filename);
  reset(eingabe);




  randomize;
  writeln(ausgabe);
  writeln(ausgabe);

  zeichenausgabe('V');
  zeichenausgabe('V');
  zeichenausgabe('V');
  delay(1000);

  zeichenausgabe('#'); {commence traffic}
  delay(500);

  while not eof(eingabe) do
    begin
    read(eingabe,zeichen);
    write(ausgabe,zeichen);
    zeichenausgabe(zeichen);
    end;

  zeichenausgabe('+'); {ar}
  writeln(ausgabe);
  writeln(ausgabe,'+');

  repeat until keypressed;
  code:=readkey;


end;


begin {of main}

port[comport+4]:=3;
nosound;

clrscr;

write('BpM ?  ');
readln(bpm);

write('Extrapause ? ');
readln(extrapause);

write('Lektion (1-19) : ');
readln(lektionsnr);





{write('nur neue Zeichen ?  : ');} {Hab'ich mal eingebaut, um die neuen}
{readln(nurneu);}                  {Zeichen einer Lektion in's Ohr zu kriegen.}
nurneu:='n';



punktdauer:=trunc(100.0/bpm*60.0 / olitaktcor + 0.5);


repeat
clrscr;
writeln('(1) Morseschreiber');
writeln('(2) Morselektion');
writeln('(3) File ausgaben');
writeln;
writeln('(0) Ende');
repeat until keypressed;
code:=readkey;
case code of
  '1': morseschreiber;
  '2': morselektion;
  '3': morsefile;

end;
until code='0';


end.
